<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_forum_attachments', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for attachments table";
		}
	}
	
	echo '
	<h3>Transfer Message Attachments</h3>
	<p>
		There are '.$recordCount.' items for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh.';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_attachments&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$start = isset($_GET['start']) ? $_GET['start'] : 0;
	if ($start > 0) {
		$CLEAR = 0;
	}
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$FINISHED = false;
	
	if ($dbSource && $dbSink) {
		
		if ($CLEAR == 1) {
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_attachments";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
		}
		
		
		$q = "
			SELECT *
			FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_forum_attachments
		";
		
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi_msgtxt = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_attachments (
			`mesid`, `filelocation`) VALUES ";
		
		$rows = array();
		
		$msg_updates = array();
		
		$msg_upd_prefix = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text SET message = message + '
		
		' + '";
		
		
		
		$count = 0;
		
		$mblock = 1000;
		$curr = 0;
		
		$FILE_PREFIX = "/home/aussiesl/public_html/forum/attachments/";
		$IMG_PREFIX = "/home/aussiesl/public_html/forum/attachments/";
		
		$FILE_WEB = "[file name=FN size=SZ]/forum/attachments/FN[/file]";
		$IMG_WEB = "[img]/forum/attachments/FN[/img]";
		
		$imgs = array(".gif",".jpg",".png",".jpeg");
		
		while ($rw = dbGetRowHash($rs)) {
			
			$attach = "";
			if (in_array($rw['attach_ext'], $imgs)) {
				
				$attach = $IMG_PREFIX . $rw['attach_name'];
				$msg_updates[] = $msg_upd_prefix . str_replace( "FN", $rw['attach_name'], $IMG_WEB) . "' WHERE messid = " . $rw['post_id'];

			} else {
				$attach = $FILE_PREFIX . $rw['attach_name'];
				
				$attsz = 0;
				if (isNumeric($rw['attach_size'])) {
					$attsz = $rw['attach_size'] / 1024;
				}
				
				$innard = str_replace( "FN", $rw['attach_name'], $FILE_WEB);
				$innard = str_replace( "SZ", $attsz, $innard);
				
				$msg_updates[] = $msg_upd_prefix . $innard . "' WHERE messid = " . $rw['post_id'];

			}
					
			
			$rows[] = "(".$rw['post_id'].", '".$attach."')";
			
			
			
			$count++;
			$curr++;
			
			if (count($rows) > 0 && $curr == $mblock) {
				
				$m_q = $qi_msgtxt . implode(",", $rows);
				$r = dbQuery($m_q, $dbSink);
				$rows = array();
				$curr = 0;
			}
		}
		if (count($rows) > 0 && $curr < $mblock) {
			
			$m_q = $qi_msgtxt . implode(",", $rows);
			$r = dbQuery($m_q, $dbSink);
			$rows = array();
			$curr = 0;
		}
		
		// Now do all the message updates:
		
		foreach ($msg_updates as $mq) {
			
			$r = dbQuery($mq, $dbSink);
			
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$count.' post attachments were transferred...<br />
		<br />
	</p>
	<p>
		Done...
	</p>
	';
	
}
?>