<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	echo '
	<h3>Final Tidying Up</h3>
	<p>
		Proceed? [<a href="index.php?act=convert_finalfixes&step=1">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	if ($dbSource && $dbSink) {
		
		$queries = array();
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text SET message = replace(message , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text SET message = replace(message , '&quot;','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages SET subject = replace(subject , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories SET name = replace(name , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories SET description = replace(description , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages SET subject = replace(subject , '&quot;','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_users SET signature = replace(signature , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_users SET signature = replace(signature , '&quot;','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_users SET location = replace(location , '&#39;','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_users SET avatar = 'components/com_community/assets/default.jpg' WHERE avatar =  ''";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_users SET thumb = 'components/com_community/assets/default_thumb.jpg' WHERE thumb =  ''";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET title = replace(title , '“','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET introtext = replace(introtext , '“','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET fulltext = replace(fulltext , '“','\"');";		
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET title = replace(title , '','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET introtext = replace(introtext , '','\"');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET fulltext = replace(fulltext , '','\"');";		
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET title = replace(title , '’','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET introtext = replace(introtext , '’','\'');";
		$queries[] = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content SET fulltext = replace(fulltext , '’','\'');";
		
	
		foreach ($queries as $q) {
			logQuery($q);
			$r = dbQuery($q, $dbSink);
		}
		
		$FINISHED = true;
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$count.' Stuff was fixed up....<br />
		<br />
	</p>
	<p>
		Done...
	</p>
	';
	
}
?>