<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_posts', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for threads table";
		}
	}
	
	echo '
	<h3>Transfer Threads</h3>
	<p>
		There are '.$recordCount.' posts for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh.';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_threads&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$start = isset($_GET['start']) ? $_GET['start'] : 0;
	$blockSize = 50000;
	//$blockSize = 2;
	//forum='.$last_forum.'&thread='.$my_thread_id.'&post='.$last_post.'&start='.$start.
	$forum = isset($_GET['forum']) ? $_GET['forum'] : 0;
	$thread = isset($_GET['thread']) ? $_GET['thread'] : 0;
	$post = isset($_GET['post']) ? $_GET['post'] : 0;
	
	if ($start > 0) {
		$CLEAR = 0;
	}
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$FINISHED = false;
	
	if ($dbSource && $dbSink) {
		
		$post_count = 0;
		
		if ($CLEAR == 1) {
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
		}
		
		$q = "
			SELECT p.*, u.user_name, u.user_email, t.thread_views
			FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_posts p
			LEFT JOIN ".$settings['fusion_db'].".".$settings['fusion_prefix']."_users u ON p.post_author = u.user_id
			LEFT JOIN ".$settings['fusion_db'].".".$settings['fusion_prefix']."_threads t ON p.thread_id = t.thread_id
			ORDER BY forum_id, thread_id, post_id LIMIT $start, $blockSize";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi_msg = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages (
			`id`, `parent`, `thread`,
			`catid`, `name`, `userid`,
			`email`, `subject`, `time`,
			`ip`, `topic_emoticon`, `locked`,
			`hold`, `ordering`, `hits`, `moved`,
			`modified_by`, `modified_time`,
			`modified_reason`) VALUES ";
			
		
		/*
		$qi_msgtxt = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text (
			`mesid`, `message`) VALUES ";
		*/
		
		$rows = array();
		
		$mblock = 2000;
		$curr = 0;
		
		$my_thread_id = $thread;
		$my_parent_id = 0;
		
		$last_fusion_thread = 0;
		
		$last_forum = $forum;
		$last_post = $post;
		
		while ($rw = dbGetRowHash($rs)) {
			if ($my_thread_id == 0) {
				
				$my_thread_id = $rw['post_id'];
				$last_fusion_thread = $rw['thread_id'];
				
			} else if ($last_fusion_thread != $rw['thread_id']) {
				// new thread
				$my_thread_id = $rw['post_id'];
				$last_fusion_thread = $rw['thread_id'];
				
			}
			
			if ($rw['post_id'] == $my_thread_id) {
				$my_parent_id = 0;// its me!
			} else {
				$my_parent_id = $my_thread_id;
			}
			
			$views = 0;
			if (isNumeric($rw['thread_views'])) {
				$views = $rw['thread_views'];
			}
			
			//0, NULL, NULL, NULL),(2195, 2194, '2194', 4, 'Quje', 17, 'quennyboy@ho
			$rows[] = "(".$rw['post_id'].", ".$my_parent_id.", ".$my_thread_id.", 
				".$rw['forum_id'].", '".$rw['user_name']."', ".$rw['post_author'].",
				'".prepTextForDB($rw['user_email'])."', '".prepTextForDB($rw['post_subject'])."', '".$rw['post_datestamp']."',
				'".$rw['post_ip']."', 0, 0,
				0, 0, ".$views.", 0, NULL, NULL, NULL)";
			
			$post_count++;
			$last_forum = $rw['forum_id'];
			$last_post = $rw['post_id'];
			$curr++;
			
			if (count($rows) > 0 && $curr == $mblock) {
				
				$m_q = $qi_msg . implode(",", $rows);
				$r = dbQuery($m_q, $dbSink);
				$rows = array();
				$curr = 0;
			}
			
		}
		
		if (count($rows) > 0 && $curr < $mblock) {
			
			$m_q = $qi_msg . implode(",", $rows);
			$r = dbQuery($m_q, $dbSink);
			$rows = array();
			$curr = 0;
		}
		
		if ($post_count < $blockSize) {
			$FINISHED = true;
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$post_count.' posts were transferred...<br />
		<br />
		Ended on: forum: '.$last_forum.' in thread: '.$my_thread_id.' and post: '.$last_post.'<br />
	</p>
	';
	if (! $FINISHED) {
		$start = $start + $blockSize;
		echo '
		<p>
			Proceed Onward? [<a href="index.php?act=convert_threads&step=1&forum='.$last_forum.'&thread='.$my_thread_id.'&post='.$last_post.'&start='.$start.'&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	} else {
		echo '
		<p>
			Proceed On To Message Attachments? [<a href="index.php?act=convert_threads&step=3&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	}
} else if ($STEP == 2) {
	/* BYPASSED FOR NOW, SEE SEPERATE IMPORTER */
	$start = isset($_GET['start']) ? $_GET['start'] : 0;
	$blockSize = 50000;
	//$blockSize = 2;
	
	if ($start > 0) {
		$CLEAR = 0;
	}
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$FINISHED = false;
	
	if ($dbSource && $dbSink) {
		$q = "
			SELECT p.post_id, p.post_message
			FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_posts p
			ORDER BY post_id LIMIT $start, $blockSize";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi_msgtxt = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text (
			`mesid`, `message`) VALUES ";
		
		$rows = array();
		
		$count = 0;
		
		$mblock = 5000;
		$curr = 0;
		
		while ($rw = dbGetRowHash($rs)) {
			$rows[] = "(".$rw['post_id'].", '".prepTextForDB($rw['post_message'])."')";
			
			$count++;
			$curr++;
			
			if (count($rows) > 0 && $curr == $mblock) {
				
				$m_q = $qi_msgtxt . implode(",", $rows);
				$r = dbQuery($m_q, $dbSink);
				$rows = array();
				$curr = 0;
			}
		}
		if (count($rows) > 0 && $curr < $mblock) {
			
			$m_q = $qi_msgtxt . implode(",", $rows);
			$r = dbQuery($m_q, $dbSink);
			$rows = array();
			$curr = 0;
		}
		
		if ($count < $blockSize) {
			$FINISHED = true;
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$count.' post bodies were transferred...<br />
		<br />
	</p>
	';
	if (! $FINISHED) {
		$start = $start + $blockSize;
		echo '
		<p>
			Proceed Onward? [<a href="index.php?act=convert_threads&step=2&start='.$start.'&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	} else {
		echo '
		<p>
			Proceed On To Message Attachments? [<a href="index.php?act=convert_threads&step=3&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	}
	
	
	
} else if ($STEP == 3) {
	
	$start = isset($_GET['start']) ? $_GET['start'] : 0;
	$blockSize = 50000;
	//$blockSize = 2;
	
	if ($start > 0) {
		$CLEAR = 0;
	}
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$FINISHED = false;
	
	if ($dbSource && $dbSink) {
		$q = "
			SELECT *
			FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_forum_attachments
			ORDER BY post_id LIMIT $start, $blockSize";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi_start = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_attachments (
			`mesid`, `filelocation`) VALUES ";
		
		$rows = array();
		
		$count = 0;
		
		$mblock = 5000;
		$curr = 0;
		
		while ($rw = dbGetRowHash($rs)) {
			$rows[] = "(".$rw['post_id'].", '".$rw['attach_name']."')";
			
			$count++;
			$curr++;
			
			if (count($rows) > 0 && $curr == $mblock) {
				
				$m_q = $qi_start . implode(",", $rows);
				$r = dbQuery($m_q, $dbSink);
				$rows = array();
				$curr = 0;
				
			}
		}
		if (count($rows) > 0 && $curr < $mblock) {
			
			$m_q = $qi_start . implode(",", $rows);
			$r = dbQuery($m_q, $dbSink);
			$rows = array();
			$curr = 0;
		}
		
		if ($count < $blockSize) {
			$FINISHED = true;
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$count.' post attachments were transferred...<br />
		<br />
	</p>
	';
	if (! $FINISHED) {
		$start = $start + $blockSize;
		echo '
		<p>
			Proceed Onward? [<a href="index.php?act=convert_threads&step=3&start='.$start.'&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	} else {
		echo '
		<p>
			Proceed On To Forum Finalise? [<a href="index.php?act=convert_threads&step=4&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	}
	
	
	
} else if ($STEP == 4) {
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$updated = 0;
	
	if ($dbSource && $dbSink) {
		$q = "
			SELECT catid, COUNT(id) as postCount, count(thread) as topicCount, MAX(id) as lastPostId, MAX(time) as lastPostTime
			FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages
			GROUP BY thread";
		logQuery($q);
		$rs = dbQuery($q, $dbSink);
		
		while ($rw = dbGetRowHash($rs)) {
			$qu = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories SET
				id_last_msg = ".$rw['lastPostId'].",
				numTopics = ".$rw['topicCount'].",
				numPosts = ".$rw['postCount'].",
				id_last_msg = ".$rw['lastPostId'].",
				time_last_msg = '".sqlDate($rw['lastPostTime'])."'
			WHERE id = ".$rw['catid']."";
			
			logQuery($qu);
			$result = dbQuery($qu, $dbSink);
			
			$updated++;
		}
		
		$q = "
			SELECT catid, thread, MAX(hits) as hitCount
			FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages
			GROUP BY catid, thread ORDER BY catid";
		logQuery($q);
		$rs = dbQuery($q, $dbSink);
		
		$last_cat_id = 0;
		$curr_count = 0;
		
		while ($rw = dbGetRowHash($rs)) {
			if ($last_cat_id == 0) {
				$last_cat_id = $rw['catid'];
			} else if ($last_cat_id != $rw['catid']) {
				$q = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories SET
					hits = ".$curr_count." WHERE id = ".$last_cat_id."";
					
				logQuery($q);
				$result = dbQuery($q, $dbSink);
				$curr_count = 0;
			}
			$curr_count += $rw['hitCount'];
		}
		
		if ($curr_count > 0) {
			$q = "UPDATE ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories SET
				hits = ".$curr_count." WHERE id = ".$last_cat_id."";
				
			logQuery($q);
			$result = dbQuery($q, $dbSink);
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$updated.' topics were updated...<br />
		<br />
	</p>
	';
}
