<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_forums', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for forums table";
		}
	}
	
	echo '
	<h3>Transfer Forums</h3>
	<p>
		There are '.$recordCount.' forums for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh.';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_forums&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$forum_count = 0;
	
	if ($dbSource && $dbSink) {
		
		if ($CLEAR == 1) {
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			
		}
		
		$q = "SELECT * FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_forums";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_categories (
				`id`, `parent`, `name`, `cat_emoticon`, `locked`, `alert_admin`,
				`moderated`, `moderators`, `pub_access`, `pub_recurse`, `admin_access`,
				`admin_recurse`, `ordering`, `future2`, `published`, `checked_out`,
				`checked_out_time`, `review`, `hits`, `description`, `headerdesc`,
				`class_sfx`, `id_last_msg`, `numTopics`, `numPosts`, `time_last_msg`
			) VALUES ";
			
		$rows = array();
		
		while ($rw = dbGetRowHash($rs)) {
			
			$moderated = (isNumeric($rw['forum_cat']) && $rw['forum_cat'] > 0) ? 1 : 0;
			$mods = "NULL";
			if ($moderated == 1) {
				$mods = "NULL";
			}
			
			$rows[] = "(".$rw['forum_id'].", ".$rw['forum_cat'].", '".prepTextForDB($rw['forum_name'])."', 
				0, 0, 0, ".$moderated.", ".$mods.", 0, 0, 0, ".$moderated.", ".$rw['forum_order'].",
				0, 1, 0, NULL, 0, 0, '".prepTextForDB($rw['forum_description'])."', '', '',
				0, 0, 0, '".sqlDate($rw['forum_lastpost'])."')";
			
			$forum_count++;
		}
		
		$qi .= implode(",", $rows);
		
		$r = dbQuery($qi, $dbSink);
		
	} else {
		addError("Unable to connect to databases");
	}
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$forum_count.' forums were transferred.
	</p>
	<p>
		Proceed On To Threads? [<a href="index.php?act=convert_threads&step=0&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
}
