<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_posts', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for threads table";
		}
	}
	
	echo '
	<h3>Transfer Message Bodies</h3>
	<p>
		There are '.$recordCount.' posts for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh.';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_msgbodies&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$start = isset($_GET['start']) ? $_GET['start'] : 0;
	$blockSize = 50000;
	//$blockSize = 2;
	
	if ($start > 0) {
		$CLEAR = 0;
	}
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$FINISHED = false;
	
	if ($dbSource && $dbSink) {
		
		if ($CLEAR == 1) {
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
		}
		
		
		$q = "
			SELECT p.post_id, p.post_message
			FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_posts p
			ORDER BY post_id LIMIT $start, $blockSize";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		$qi_msgtxt = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_messages_text (
			`mesid`, `message`) VALUES ";
		
		$rows = array();
		
		$count = 0;
		
		$mblock = 1000;
		$curr = 0;
		
		while ($rw = dbGetRowHash($rs)) {
			$rows[] = "(".$rw['post_id'].", '".prepTextForDB($rw['post_message'])."')";
			
			$count++;
			$curr++;
			
			if (count($rows) > 0 && $curr == $mblock) {
				
				$m_q = $qi_msgtxt . implode(",", $rows);
				$r = dbQuery($m_q, $dbSink);
				$rows = array();
				$curr = 0;
			}
		}
		if (count($rows) > 0 && $curr < $mblock) {
			
			$m_q = $qi_msgtxt . implode(",", $rows);
			$r = dbQuery($m_q, $dbSink);
			$rows = array();
			$curr = 0;
		}
		
		if ($count < $blockSize) {
			$FINISHED = true;
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$count.' post bodies were transferred...<br />
		<br />
	</p>
	';
	if (! $FINISHED) {
		$start = $start + $blockSize;
		echo '
		<p>
			Proceed Onward? [<a href="index.php?act=convert_msgbodies&step=1&start='.$start.'&clear=0">Yes</a>] [<a href="index.php">No</a>]
		</p>
		';
	} else {
		echo '
		<p>
			Done...
		</p>
		';
	}
	
}
