<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_users', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for users table";
		}
		
	}
	
	echo '
	<p>
		There are '.$recordCount.' users for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh. This will not clear the user at id number 1...';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_users&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$usr_count = 0;
	
	if ($dbSource && $dbSink) {
		
		if ($CLEAR == 1) {
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_users WHERE id > 0";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_aro WHERE section_value = 'users' AND value > 0";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			$q = "SELECT id FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_aro WHERE section_value = 'users' AND value = 0";
			logQuery($q);
			$aro_id = dbGetOneValue($q, $dbSink);
			if (isNumeric($aro_id)) {
				$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_groups_aro_map WHERE aro_id != ".$aro_id;
				logQuery($q);
				$r = dbQuery($q, $dbSink);
			} else {
				$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_groups_aro_map WHERE group_id != 25";
				logQuery($q);
				$r = dbQuery($q, $dbSink);
			}
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_users WHERE userid > 0";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_fields_values WHERE user_id > 0";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_users WHERE userid > 0";
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
		}
		
		$q = "SELECT * FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_users WHERE user_id > 0";
		logQuery($q);
		$rs = dbQuery($q, $dbSource);
		
		while ($rw = dbGetRowHash($rs)) {
			
			$gid = 18;
			$utype = 'Registered';
			if ($rw['user_level'] == 103) {
				$gid = 25;
				$utype = 'Super Administrator';
			} else if ($rw['user_level'] == 102) {
				$gid = 24;
				$utype = 'Administrator';
			}
			/*
			** Skip this, final system will incorporate import into community or similar
			$added = array();
			$added[] = 'location='.$rw['user_location'];
			$added[] = 'birthdate='.$rw['user_birthdate'];
			$added[] = 'aim='.$rw['user_aim'];
			$added[] = 'icq='.$rw['user_icq'];
			$added[] = 'msn='.$rw['user_msn'];
			$added[] = 'yahoo='.$rw['user_yahoo'];
			$added[] = 'web='.$rw['user_web'];
			$added[] = 'offset='.$rw['user_offset'];
			$added[] = 'avatar='.$rw['user_avatar'];
			$added[] = 'sig='.$rw['user_sig'];
			*/
			$params=
			"editor=
			language=
			timezone=".$rw['user_offset'];
			
			$block = 0;
			if ($rw['user_status'] == 1) {
				$block = 1;
			}
			
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_users (
				id, name, username, email, password, usertype, block,
				sendEmail, gid, registerDate, lastvisitDate, activation, params
			) VALUES (
				".$rw['user_id'].", '".$rw['user_name']."', '".$rw['user_name']."', 
				'".$rw['user_email']."', '".$rw['user_password']."', '".$utype."',
				".$block.", 0, ".$gid.", '".sqlDate($rw['user_joined'])."', '".sqlDate($rw['user_lastvisit'])."',
				'', '".$params."'
			)";
			
			logQuery($qi);
			
			$u_id = dbInsert($qi, $dbSink);
			
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_aro (
				section_value, value, order_value, name, hidden
			) VALUES (
				'users', ".$u_id.", 0, '".$rw['user_name']."', 0
			)";
			logQuery($qi);
			$u_aro_id = dbInsert($qi, $dbSink);
			
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_core_acl_groups_aro_map (
				group_id, section_value, aro_id
			) VALUES (
				".$gid.", '', ".$u_aro_id."
			)";
			
			logQuery($qi);
			$rid = dbInsert($qi, $dbSink);
			$params = 
"notifyEmailSystem=1
privacyProfileView=20
privacyPhotoView=20
privacyFriendsView=20
privacyVideoView=1
notifyEmailMessage=1
notifyEmailApps=1
daylightsavingoffset=0
";
			$m_avatar = "";
			if (strlen(trim($rw['user_avatar'])) > 0) {
				$m_avatar = 'images/avatar/old/'.$rw['user_avatar'];
			}
			
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_users (
				userid, status, points, posted_on, avatar, thumb, invite, params, view, friendcount
			) VALUES (
				".$u_id.", '', 0, '0000-00-00 00:00:00', '".$m_avatar."', '".$m_avatar."', 0, '".$params."', 0, 0
			)";
			logQuery($qi);
			$rid = dbInsert($qi, $dbSink);
			
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_community_fields_values (
				user_id, field_id, value
			) VALUES ";
			$rows = array();
			if (strlen(trim($rw['user_birthdate'])) > 0) {
				$rows[] = "(".$u_id.", 3, '".$rw['user_birthdate']."')";
			}
			$rows[] = "(".$u_id.", 19, '".$rw['user_blog']."')";
			$rows[] = "(".$u_id.", 18, '".$rw['postcode']."')";
			$rows[] = "(".$u_id.", 10, '')";
			$rows[] = "(".$u_id.", 11, '".$rw['user_location']."')";
			$rows[] = "(".$u_id.", 12, 'Australia')";
			$rows[] = "(".$u_id.", 13, '".$rw['user_web']."')";
			
			$qi .= implode(",", $rows);
			
			logQuery($qi);
			$rid = dbQuery($qi, $dbSink);
			
			// Now for Kuena export
			/*
			//'Jack of all Trades - Master of None.\r\n[url]http://www.aussieslivingsimply.com.au[/url]\r\n[url=http://www.webbcon.com.au]WEBBCON - Custom Sheet Metal Fabrication[/url]\r\n[url=http://www.veryediblegardens.com]VEG - Fully installed organic vegetable gardens[/url]'
			//INSERT INTO `jos_fb_users` (
			`userid`, `view`, `signature`, `moderator`, `ordering`, `posts`,
			(1,       'flat', 'sig',        0,           0,         3008, 
			`avatar`, `karma`, `karma_time`, `group_id`, `uhits`, `personalText`, 
			NULL,      0, 		0, 				1, 			0,	 NULL,
			`gender`, `birthdate`, `location`, `ICQ`, `AIM`, `YIM`, `MSN`, `SKYPE`, `GTALK`, `websitename`, `websiteurl`, `rank`, `hideEmail`, `showOnline`) VALUES
			0, '0001-01-01', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 1, 1),
			*/
			$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_fb_users (
				`userid`, `view`, `signature`, `moderator`, `ordering`, `posts`,
				`avatar`, `karma`, `karma_time`, `group_id`, `uhits`, `personalText`,
				`gender`, `birthdate`, `location`,
				`ICQ`, `AIM`, `YIM`, `MSN`,
				`SKYPE`, `GTALK`, `websitename`, `websiteurl`, `rank`, `hideEmail`, `showOnline`
			) VALUES (
				".$u_id.", 'flat', '".prepTextForDB($rw['user_sig'])."', 0, 0, ".$rw['user_posts'].",
				NULL, 0, 0, 1, 0, NULL,
				0, '".$rw['user_birthdate']."', '".substr($rw['user_location'], 0, 50)."',
				'".$rw['user_icq']."', '".$rw['user_aim']."', '', '".$rw['user_msn']."',
				'', '',  '', '".$rw['user_web']."', 0, 1, 1
			)";
			logQuery($qi);
			$rid = dbInsert($qi, $dbSink);
			
			$usr_count++;
		}
		
	} else {
		addError("Unable to connect to databases");
	}
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$usr_count.' users were transferred.
	</p>
	';
	
	
}
